package com.translogicsys.aspect;

import junit.framework.TestCase;
import java.util.*;

/**
 * @author karuku
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class MockTestCase extends TestCase {

	private static Hashtable testData = new Hashtable();
	private static Hashtable callsMade = new Hashtable();
	private static Map exceptions = new HashMap();

	/**
	 * Constructor for SampleIssueContactTest.
	 * @param arg0
	 */
	public MockTestCase(String arg0) {
		super(arg0);
	}

	public static void setMock(String className, String methodName, Object returnValue){
		testData.put(makeKey(className, methodName), returnValue);
	}

	public static void setMock(String className, String methodName){
		setMock(className, methodName, new Object());
	}

	public static Object getMockReturnValue(String className, String methodName){
		return testData.get(makeKey(className, methodName));
	}

	public void assertCalled(String className, String methodName){
		if ( ! isCalled(className, methodName) )
				fail("The method '" + methodName + "' in class '" +
						className + "' was expected to be called but it wasn't");
	}

	public Object getArgument(String className, String methodName, String argumentName){
		Object argument = null;
		Hashtable arguments = (Hashtable)callsMade.get(makeKey(className, methodName));
		if (arguments != null)
			argument = arguments.get(argumentName);
		return argument;
	}

	public static void indicateCalled(String className, String methodName, Hashtable arguments)	{
		callsMade.put(makeKey(className, methodName), arguments);
	}

	public static boolean isCalled(String className, String methodName){
		return callsMade.get(makeKey(className, methodName)) != null;
	}

	public void assertArgumentPassed(String className, String methodName,
								String argumentName, Object argumentValue){
		Object argument = getArgument(className, methodName, argumentName);
		if (argument == null || !argument.equals(argumentValue))
			fail("The argument '" + argumentName + "' of method '" +
					methodName + "' in class '" +
					className + " ' should have the value '" +
					argumentValue + "' but it was '" +
					argument + "'!");
	}

	private static String makeKey(String className, String methodName){
		return className + "." + methodName;
	}


	public static void setMockException(String className, String methodName,Throwable t)
    {
        exceptions.put(makeKey(className, methodName), t);
    }

    public static Object getMockException(String className, String methodName)
    {
		return exceptions.get(makeKey(className, methodName));
    }
	public static Object removeMock(String className, String methodName) {
		return testData.remove(makeKey(className, methodName));
	}
}